/* *           Copyright (c) 2004, Daniel M. Bikel.
 *                         All rights reserved.
 * 
 *                Developed at the University of Pennsylvania
 *                Institute for Research in Cognitive Science
 *                    3401 Walnut Street
 *                    Philadelphia, Pennsylvania 19104
 * 			
 * 
 * For research or educational purposes only.  Do not redistribute.  For
 * complete license details, please read the file LICENSE that accompanied
 * this software.
 * 
 * DISCLAIMER
 * 
 * Daniel M. Bikel makes no representations or warranties about the suitability of
 * the Software, either express or implied, including but not limited to the
 * implied warranties of merchantability, fitness for a particular purpose, or
 * non-infringement. Daniel M. Bikel shall not be liable for any damages suffered
 * by Licensee as a result of using, modifying or distributing the Software or its
 * derivatives.
 * 
 */
    package danbikel.parser.arabic;

import java.util.BitSet;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Set;
import java.util.StringTokenizer;
import danbikel.lisp.*;
import danbikel.parser.Language;
import danbikel.parser.Nonterminal;

/*
 * Provides data and methods speciifc to the structures found in the English
 * Treebank (the
 * <a target="_blank"
 * href="http://www.cis.upenn.edu/~treebank/">Penn Treebank</a>) or any other
 * treebank that conforms to the Treebank II annotation guidelines for
 * <a target="_blank" href="ftp://ftp.cis.upenn.edu/pub/treebank/doc/tagguide.ps.gz">part-of-speech tagging</a>
 * and
 * <a target="_blank"
 * href="ftp://ftp.cis.upenn.edu/pub/treebank/doc/manual/">bracketing</a>.
 */

/**
 * Provides data and methods speciifc to the structures found in the English
 * Treebank (the Penn Treebank) or any other treebank that conforms to the
 * Treebank II annotation guidelines for part-of-speech tagging and bracketing.
 */
public class Treebank4 extends danbikel.parser.arabic.Treebank3 {

  public boolean constainsDeterminer(Symbol label) {
    return label.toString().startsWith("DT");
  }
}
