package danbikel.parser.examine;

import danbikel.parser.Constants;
import danbikel.parser.HeadFinder;
import danbikel.parser.Language;
import danbikel.parser.Treebank;
import danbikel.parser.Settings;
import danbikel.parser.Nonterminal;
import danbikel.parser.Word;
import danbikel.parser.Words;
import danbikel.util.*;
import danbikel.lisp.*;
import java.util.*;
import java.io.*;


class TreeMapKey {
    int numEntries;
    String key;
    
    public TreeMapKey(int numEntries, String key) {
	this.numEntries=numEntries;
	this.key=key;
    }
}



public abstract class ExamineConstituent extends ExamineCore {

    java.util.HashMap map=null;

    Comparator c= new Comparator() {
	    public int compare(Object obj1,Object obj2) {
		TreeMapKey o1=(TreeMapKey)obj1;
		TreeMapKey o2=(TreeMapKey)obj2;
		if (o1.numEntries<o2.numEntries) {
		    return 1;
		} else if (o1.numEntries>o2.numEntries) {
		    return -1;
		} else {
		    return (o1.key).compareTo(o2.key);
		}
	    }
	};
    TreeMap sortedEntries=new TreeMap(c);
    int count=0;

    public void sortResults() {
	int count2=0;
	Iterator keys=map.keySet().iterator();
	while (keys.hasNext()) {
	    String key=(String)keys.next();
	    ArrayList entries=(ArrayList)map.get(key);
	    if (entries==null) {
		System.out.println("no entry  for key=" +key);
		System.exit(-1);
	    }
	    //	    System.out.println("adding in entry size="+entries.size()+" key="+key);
	    count2+=entries.size();
	    sortedEntries.put(new TreeMapKey(entries.size(),key),entries);
	}
	System.out.println("shoudl be "  +count + " was " + count2);
    }

	    
    protected void showResults() {
	int total=0;
	Iterator keys=sortedEntries.keySet().iterator();
	while (keys.hasNext()) {
	    TreeMapKey key=(TreeMapKey)keys.next();
	    ArrayList entries=(ArrayList)sortedEntries.get(key);
	    total+=entries.size();
	    System.out.println(danbikel.parser.util.SKUtil.leftJustify(30,key.key) + danbikel.parser.util.SKUtil.rightJustify(6,entries.size()) + " "  + danbikel.parser.util.SKUtil.rightJustify(6,total));
	}
	System.out.println("-----------------------------------------------------");
	keys=sortedEntries.keySet().iterator();
	while (keys.hasNext()) {
	    TreeMapKey key=(TreeMapKey)keys.next();
	    System.out.println("-----------------------------------------------------");
	    ArrayList entries=(ArrayList)sortedEntries.get(key);
	    System.out.println(danbikel.parser.util.SKUtil.leftJustify(30,key.key) + danbikel.parser.util.SKUtil.rightJustify(6,entries.size()));
	    showEntries(key.key,entries);
	}
    }


    public ExamineConstituent(boolean bothTags) {
	super(bothTags);
	map=new java.util.HashMap();
    }

    public void process(List files) 
	throws FileNotFoundException,IOException {

	for (Iterator fileIter = files.iterator(); fileIter.hasNext(); ) {
	    String baseFileName=(String)fileIter.next();
	    //	    String inFileName=baseFileName+defaultExtension;
	    process(baseFileName);
	}
	System.out.println("sorting results");
	sortResults();
	System.out.println("showing results");
	showResults();
    }


    /*
    protected void showResults() {
	Iterator keys=map.keySet().iterator();
	while (keys.hasNext()) {
	    String key=(String)keys.next();
	    ArrayList entries=(ArrayList)map.get(key);
	    System.out.println("key="+key + " # entries="+entries.size());
	    showEntries(key,entries);
	}
    }
    */


}
