package danbikel.parser.examine;

import danbikel.parser.Constants;
import danbikel.parser.HeadFinder;
import danbikel.parser.Language;
import danbikel.parser.Treebank;
import danbikel.parser.Settings;
import danbikel.parser.Nonterminal;
import danbikel.parser.Word;
import danbikel.parser.Words;
import danbikel.util.*;
import danbikel.lisp.*;
import java.util.*;
import java.io.*;

public class ExamineContext extends ExamineCore {

    java.util.HashMap map=null;

    public ExamineContext(boolean bothTags, String listOfWords) {
	super(bothTags);
	map=new java.util.HashMap();
	//	map.put(">fdH",new ArrayList());
	try {
	    BufferedReader reader=new 
		BufferedReader(new 
			       FileReader(listOfWords));
	    String line=reader.readLine();
	    while (line!=null) {
		String[] parts=line.split(" ");
		String word=parts[0].trim();
		if (word.length()>0) {
		    System.out.println("word to check="+word);
		    map.put(word,new ArrayList());
		}
		line=reader.readLine();
	    }
	}
	catch (Exception e) {
	    System.out.println("exception " + e);
	    e.printStackTrace();
	    System.exit(-1);
	}

    }
    /*
	map.put("kl",new ArrayList());
	map.put("Ay",new ArrayList());
	map.put("bED",new ArrayList());
	map.put(">y",new ArrayList());
	map.put("jmyE",new ArrayList());
	map.put("r}ys",new ArrayList());
	map.put("bDEp",new ArrayList());
	map.put(">CCC",new ArrayList());
    */

    boolean specialType (String str) {
	if (str.length()!=4) 
	    return false;
	if (!str.substring(0,1).equals(">"))
	    return false;
	return true;
    }

	


    protected void showResults() {
	Iterator keys=map.keySet().iterator();
	while (keys.hasNext()) {
	    String key=(String)keys.next();
	    ArrayList entries=(ArrayList)map.get(key);
	    ArrayList firstChildBaseNP=new ArrayList();
	    ArrayList onlyChildBaseNP=new ArrayList();
	    ArrayList otherChildBaseNP=new ArrayList();
	    ArrayList otherContext=new ArrayList();
	    for (int i=0; i<entries.size(); i++) {
		ContextInfo entry=(ContextInfo)entries.get(i);
		if (entry.siblingsAllPreterminals && 
		   entry.parentIsNP) {
		    if (entry.childNum==0) {
			if (entry.words.length==1) {
			    onlyChildBaseNP.add(entry);
			} else {
			    firstChildBaseNP.add(entry);
			}
		    } else {
			otherChildBaseNP.add(entry);
		    }
		} else {
		    otherContext.add(entry);
		}
	    }
	    System.out.println("------------------------------------------------");
	    System.out.println("word="+key);
	    System.out.println("firstChildBaseNP "+firstChildBaseNP.size());
	    System.out.println("onlyChildBaseNP "+onlyChildBaseNP.size());
	    System.out.println("otherChildBaseNP "+otherChildBaseNP.size());
	    System.out.println("otherContext "+otherContext.size());
	    showEntries("firstChildBaseNP",firstChildBaseNP);
	    showEntries("onlyChildBaseNP",onlyChildBaseNP);
	    showEntries("otherChildBaseNP",otherChildBaseNP);
	    showEntries("otherContext",otherContext);
	}
    }


    protected void process(Sexp tree) {
	if (Language.treebank().isPreterminal(tree)) {
	  return;
      }
      else if (tree.isList()) {
	  SexpList treeList = tree.list();
	  ContextInfo contextInfo=null;
	  for (int i = 1; i < treeList.length(); i++) {
	      Sexp child=treeList.get(i);
	      if (Language.treebank().isPreterminal(child)) {
		  Symbol currLabel = treeList.symbolAt(0);
		  String currLabelStr=currLabel.toString();
		  String currWordStr=child.list().symbolAt(1).toString();
		  /*
		  if (specialType(currWordStr)) {
		      currWordStr=">CCC";
		  }
		  */
		  /*
		      if (map.get(currWordStr)==null) {
		        map.put(currWordStr,new ArrayList());
			  System.out.println("added entry for " + currWordStr);
		      }
		  }
		  */
		  ArrayList entries=(ArrayList)(map.get(currWordStr));
		  if (entries!=null) {
		      //		      System.out.println("found " + currWordStr + " at " + currentFilename+"/"+currentSentNum);
		      if (contextInfo==null) {
			  contextInfo=new ContextInfo();
			  getContextInfo(treeList,contextInfo);
			  contextInfo.childNum=i-1;
			  entries.add(contextInfo);
		      } else {
			  System.out.println("context info already exists!" + currWordStr + " at " + currentFilename+"/"+currentSentNum);
		      }
		  }
	      }
	  }
	  for (int i = 1; i < treeList.length(); i++) {
	      process(treeList.get(i));
	  }
      }
    }


    public static void main(String[] args) {
	boolean bothTags= (args[0].equals("true")) ? true : false;
	String listOfWords=args[1];
	ArrayList dir=new ArrayList();
	dir.add(new File(args[2]));
	
	//	System.out.println("added"+args[1]+"to dir");
	List files=danbikel.parser.util.SKUtil.expandDirectories(dir,defaultExtension,false,false);
	try {
	    ExamineContext examineContext=new ExamineContext(bothTags,listOfWords);
	    examineContext.process(files);
	}
	catch (FileNotFoundException fnfe) {
	System.err.println(fnfe);
	}
	catch (IOException ioe) {
	    System.err.println(ioe);
	    
	}
    }
}
