
    package danbikel.parser.util;

import java.io.*;
import java.util.*;
import danbikel.util.*;
import danbikel.lisp.*;
import danbikel.parser.util.*;
import danbikel.parser.*;

/* if running in mode for giving to 
level1 treebanker, then 
don't want * as root if not one of the
brackets to keep.
also give a warning if tree is compeltely invalid, like
((CODE {COM:BOOK_1}))
*/

public class StripBrackets {

    // protected static String[] bracketsToKeepStr={"S","NP"};
    //   protected static String[] bracketsToKeepStr={"IP","NP"};
    //protected static String[] bracketsToKeepStr={"IP","NP","CP"};
    //protected static String[] bracketsToKeepStr={"IP"};
    // protected static String[] bracketsToKeepStr={"NP"};
    static String[] bracketsToKeepStr=null;
    protected static ArrayList bracketsToKeep=new ArrayList();

    void initBracketsToKeep(String brackets) {
	// this is disgusting - fix it!
	if (brackets.equals("IP")) {
	    bracketsToKeepStr=new String[1];
	    bracketsToKeepStr[0]="IP";	    
	} else if (brackets.equals("IP-NP")) {
	    bracketsToKeepStr=new String[2];
	    bracketsToKeepStr[0]="IP";	    
	    bracketsToKeepStr[1]="NP";	    
	} else if (brackets.equals("S")) {
	    bracketsToKeepStr=new String[1];
	    bracketsToKeepStr[0]="S";	    
	} else if (brackets.equals("S-NP")) {
	    bracketsToKeepStr=new String[2];
	    bracketsToKeepStr[0]="S";	    
	    bracketsToKeepStr[1]="NP";	    
	}
	for (int i=0; i<bracketsToKeepStr.length; i++) {
	    System.out.println("bracketsToKeep["+i+"]="+bracketsToKeepStr[i]);
	    bracketsToKeep.add(Symbol.add(bracketsToKeepStr[i]));
	}
    }
    protected static String wildcardStr="*";
    protected static Symbol wildcard=Symbol.add(wildcardStr);
    
    public StripBrackets() {
    }

    public void process(SexpTokenizer tok, BufferedWriter outFile,String brackets) 
	throws IOException {
	
	initBracketsToKeep(brackets);
	Sexp tree=null;
	int sentNum=0;
	for (; ((tree=Sexp.read(tok))!=null); sentNum++) {
	    // strip outer bracket
	    /*
	    if (tree.list().length() == 1 &&
		tree.list().get(0).isList()) {
			tree = tree.list().get(0);
	    }
	    */
	    if (!tree.list().first().isSymbol()) {
		System.out.println("not rooted by symbol, not doing anything with " + tree);
		outFile.write(tree+"\n");
	    } else if (tree.list().length() == 1 &&
		tree.list().get(0).isList()) {
		System.out.println("not doing anything with " + tree);
		outFile.write(tree+"\n");
	    }  else {
		//		System.out.println("tree="+tree);
		Sexp taggedWords = collectBracketedWords(tree);
		outFile.write(taggedWords+"\n");
	    }
	}

	outFile.close();
    }

   Sexp collectBracketedWords(Sexp tree) {
	SexpList bracketedWords=new SexpList();
	collectLeavesWithBrackets(tree,bracketedWords);
	return bracketedWords;
    }

    Symbol isBracketToKeep(Symbol label) {
	String labelStr=label.toString();
	for (int i=0; i<bracketsToKeepStr.length; i++) {
	    //	    if (labelStr.startsWith(bracketsToKeepStr[i])) {
	    /* want to include S but not SBAR
	       didn't matter for PPCEME
	    */
	    if (labelStr.equals(bracketsToKeepStr[i]) ||
		labelStr.startsWith(bracketsToKeepStr[i]+"-") ||
		labelStr.startsWith(bracketsToKeepStr[i]+"=")) {
		return (Symbol)bracketsToKeep.get(i);
		//		return (Language.treebank().stripIndex(label));
	    }
	}
	return null;
    }

	
    void collectLeavesWithBrackets(Sexp tree, 
				   SexpList bracketedLeaves) {
	if (Language.treebank().isPreterminal(tree)) {
	    // need to include this so that -NONE- is not included as preterimanl
	       if (!Language.treebank().isNullElementPreterminal(tree)) {
		Word word = Language.treebank().makeWord(tree);
		Sexp leaf = null;
		SexpList tagList = new SexpList(1).add(word.tag());
		//	leaf = new SexpList(2).add(word.word()).add(tagList);
		leaf = new SexpList(2).add(tagList.symbolAt(0)).add(word.word());
		bracketedLeaves.add(leaf);
	       }
	}
	else if (tree.isList()) {
	    SexpList treeList = tree.list();
	    int treeListLen = treeList.length();
	    Symbol parent = treeList.first().symbol();	
	    SexpList collectChildrenLeaves=bracketedLeaves;
	    Symbol bracketToKeep=isBracketToKeep(parent);
	    if (bracketToKeep!=null) {
		/* if we're at the top level, don't add it as a child */
		if (bracketedLeaves.length()==0) {
		    bracketedLeaves.add(bracketToKeep);
		    for (int i = 0; i < treeListLen; i++) {
			collectLeavesWithBrackets(treeList.get(i), bracketedLeaves);
		    }		
		} else {    
		    SexpList subBracketLeaves=new SexpList().add(bracketToKeep);
		    for (int i = 0; i < treeListLen; i++) {
			collectLeavesWithBrackets(treeList.get(i), subBracketLeaves);
		    }		
		    if (subBracketLeaves.length()!=1) {
			bracketedLeaves.add(subBracketLeaves);
		    } else {
			System.out.println("warning: null yield for bracket  " + tree);
		    }
		}
	    } else {
		/* if we're at the top level, add * as the first bracket */
		if (bracketedLeaves.length()==0) {
		    bracketedLeaves.add(wildcard);
		}
		for (int i = 0; i < treeListLen; i++) {
		    collectLeavesWithBrackets(treeList.get(i), bracketedLeaves);
		}
	    }
	}
    }


						      
    
  public static void main(String[] args) {

      if (args.length<2) {
	  System.err.println("must have two arguments");
	  System.exit(-1);
      }

      String inFilename=args[0];
      //      String outFilename=(args.length==1) ? inFilename+".brackets" : inFilename+"."+args[1];
      String outFilename=inFilename+"."+args[1];  

      System.out.println("args[0]="+args[0]);
      if (args.length>1) {
	  System.out.println("args[1]="+args[1]);
      }
      System.out.println("inFilename="+inFilename);
      System.out.println("outFilename="+outFilename);

      InputStream inStream=null;
      BufferedWriter outFile=null;

      try {
	  inStream=new FileInputStream(inFilename);
	  String enc = System.getProperty("file.encoding");	  
	  outFile = new BufferedWriter(
				   new OutputStreamWriter(new FileOutputStream(outFilename),
							  enc));
	  StripBrackets stripBrackets=new StripBrackets();
	  stripBrackets.process(new 
	      SexpTokenizer(inStream, enc, Constants.defaultFileBufsize),
				outFile,args[1]);
      }
      catch (Exception e) {
	System.err.println(e);
	e.printStackTrace();
	System.exit(-1);
      }
  }
}


	  
	  
	  
      
      

