/* *           Copyright (c) 2004, Daniel M. Bikel.
 *                         All rights reserved.
 * 
 *                Developed at the University of Pennsylvania
 *                Institute for Research in Cognitive Science
 *                    3401 Walnut Street
 *                    Philadelphia, Pennsylvania 19104
 * 			
 * 
 * For research or educational purposes only.  Do not redistribute.  For
 * complete license details, please read the file LICENSE that accompanied
 * this software.
 * 
 * DISCLAIMER
 * 
 * Daniel M. Bikel makes no representations or warranties about the suitability of
 * the Software, either express or implied, including but not limited to the
 * implied warranties of merchantability, fitness for a particular purpose, or
 * non-infringement. Daniel M. Bikel shall not be liable for any damages suffered
 * by Licensee as a result of using, modifying or distributing the Software or its
 * derivatives.
 * 
 */
    package danbikel.parser;

import danbikel.util.*;
import danbikel.lisp.*;
import java.io.*;
import java.util.*;
import java.text.*;


public class InterpolatedKnesserNeyModel2 extends InterpolatedKnesserNeyModel  implements Serializable {

  public InterpolatedKnesserNeyModel2(ProbabilityStructure structure) {
      super(structure);
  }
    /* SK ADDED */
    public void showModel(Writer out) {
	try {
	    out.write("structure="+structure+"\n");
	    out.write("numLevels="+numLevels+"\n");
	    for (int level = 0; level < numLevels; level++) {	
		out.write("-----\nlevel\n-----\n"+level+"\n");
		Set keys=(precomputedProbs[level]).keySet();
		Iterator iter=keys.iterator();
		while (iter.hasNext()) {
		    Object key=iter.next();
		    Object value=precomputedProbs[level].getEntry(key);
		    //	  HashMapDouble.Entry entry=(HashMapDouble.Entry)iter.next();
		    //	  Object value=entry.getValue();
		    //	    out.write("key="+key+" value="+value+"\n");
		    out.write(value+"\n");
		}
	    }
	}
	catch (IOException e) {
	    System.err.println("io exception in Model.showModel"+e);
	    System.exit(-1);
	}
    }
}
