package danbikel.parser.examine;

import danbikel.parser.Constants;
import danbikel.parser.HeadFinder;
import danbikel.parser.Language;
import danbikel.parser.Treebank;
import danbikel.parser.Settings;
import danbikel.parser.Nonterminal;
import danbikel.parser.Word;
import danbikel.parser.Words;
import danbikel.util.*;
import danbikel.lisp.*;
import java.util.*;
import java.io.*;

public class ExamineBaseNPs extends ExamineConstituent {

    public ExamineBaseNPs(boolean bothTags) {
	super(bothTags);
    }


    String getKey(ContextInfo contextInfo) {
	/*
	for (int i=0; i<contextInfo.reducedTags.length; i++) {
	    System.out.println("tags["+i+"]="+contextInfo.reducedTags[i]);
	}
	*/  
    
	String key="";
	for (int i=0; i<contextInfo.reducedTags.length; i++) {
		key+=contextInfo.reducedTags[i]+" ";
	}
	return key;
    }


  protected void process(Sexp tree) {

      if (Language.treebank().isPreterminal(tree)) {
	  /*
	    SexpList treeList = tree.list();
	    Symbol currLabel = treeList.symbolAt(0);
	    treeList.set(0, treebank.getCanonical(currLabel));
	  */
	  return;
      }
      else if (tree.isList()) {
	  SexpList treeList = tree.list();
	  ContextInfo contextInfo=null;
	  boolean isNP=Language.treebank().isNP(treeList.first().symbol());
	  if (isNP) {
	      contextInfo=new ContextInfo();
	      getContextInfo(treeList,contextInfo);
	      if (contextInfo.siblingsAllPreterminals) {
		  String key=getKey(contextInfo);
		  ArrayList entries=(ArrayList)map.get(key);
		  if(entries==null) {
		      map.put(key,new ArrayList());
		      entries=(ArrayList)map.get(key);
		      //		      System.out.println("just put in null entry for key="+key);
		  }
		  entries.add(contextInfo);
		  count++;
	      }
	  }
	  for (int i = 1; i < treeList.length(); i++) {
	      process(treeList.get(i));
	  }
      }
  }

    public static void main(String[] args) {
	boolean bothTags= (args[0].equals("true")) ? true : false;
	ArrayList dir=new ArrayList();
	dir.add(new File(args[1]));
	
	//	System.out.println("added"+args[1]+"to dir");
	List files=danbikel.parser.util.SKUtil.expandDirectories(dir,defaultExtension,false,false);
	try {
	    ExamineBaseNPs examineBaseNPs=new ExamineBaseNPs(bothTags);
	    examineBaseNPs.process(files);
	}
	catch (FileNotFoundException fnfe) {
	System.err.println(fnfe);
	}
	catch (IOException ioe) {
	    System.err.println(ioe);
	    
	}
    }

}
