package danbikel.parser.examine2;

import danbikel.parser.Constants;
import danbikel.parser.HeadFinder;
import danbikel.parser.Language;
import danbikel.parser.Treebank;
import danbikel.parser.Settings;
import danbikel.parser.Nonterminal;
import danbikel.parser.Word;
import danbikel.parser.Words;
import danbikel.util.*;
import danbikel.lisp.*;
import java.util.*;
import java.io.*;


class TreeMapKey {
    int numEntries;
    String key;
    
    public TreeMapKey(int numEntries, String key) {
	this.numEntries=numEntries;
	this.key=key;
    }
}

public class CollectResults { 

    
    Comparator c= new Comparator() {
	    public int compare(Object obj1,Object obj2) {
		TreeMapKey o1=(TreeMapKey)obj1;
		TreeMapKey o2=(TreeMapKey)obj2;
		if (o1.numEntries<o2.numEntries) {
		    return 1;
		} else if (o1.numEntries>o2.numEntries) {
		    return -1;
		} else {
		    return (o1.key).compareTo(o2.key);
		}
	    }
	};

    java.util.HashMap map=new java.util.HashMap();
    TreeMap sortedMap=new TreeMap(c);
    
    void enterIntoMap(String key, ContextInfo contextInfo) {
	ArrayList entries=(ArrayList)map.get(key);
	if (entries==null) {
	    map.put(key,new ArrayList());
	    entries=(ArrayList)map.get(key);
	}
	entries.add(contextInfo);
    }
    
    public int count2;
    public int total() {
	return count2;
    }
    public void sortResults() {
	count2=0;
	Iterator keys=map.keySet().iterator();
	while (keys.hasNext()) {
	    String key=(String)keys.next();
	    ArrayList entries=(ArrayList)map.get(key);
	    if (entries==null) {
		System.out.println("no entry  for key=" +key);
		System.exit(-1);
	    }
	    //	    System.out.println("adding in entry size="+entries.size()+" key="+key);
	    count2+=entries.size();
	    sortedMap.put(new TreeMapKey(entries.size(),key),entries);
	}
	System.out.println("size="+count2);
    }
	    
    protected void showResults() {
	int total=0;
	Iterator keys=sortedMap.keySet().iterator();
	while (keys.hasNext()) {
	    TreeMapKey key=(TreeMapKey)keys.next();
	    ArrayList entries=(ArrayList)sortedMap.get(key);
	    total+=entries.size();
	    System.out.println(danbikel.parser.util.SKUtil.leftJustify(40,key.key) + 
			       danbikel.parser.util.SKUtil.rightJustify(6,entries.size()) + " "  + 
			       danbikel.parser.util.SKUtil.rightJustify(6,total));
	}
	System.out.println("-----------------------------------------------------");
	keys=sortedMap.keySet().iterator();
	while (keys.hasNext()) {
	    TreeMapKey key=(TreeMapKey)keys.next();
	    System.out.println("-----------------------------------------------------");
	    ArrayList entries=(ArrayList)sortedMap.get(key);
	    System.out.println(danbikel.parser.util.SKUtil.leftJustify(40,key.key) + 
			       danbikel.parser.util.SKUtil.rightJustify(6,entries.size()));
	    showEntries(key.key,entries);
	}
    }

		  		
    public void showEntries(String name, ArrayList entries) {
	if (entries.size()==0)
	    return;
	System.out.println();
	int maxWordsLen=-1;
	int maxReducedTagsLen=-1;
	int maxFullTagsLen=-1;

	for (int i=0; i<entries.size(); i++) {
	    ContextInfo entry=(ContextInfo)entries.get(i);
	    String wordsStr="";
	    String reducedTagsStr="";
	    String fullTagsStr="";
	    for (int j=0; j<entry.words.length; j++) {
		wordsStr+=entry.words[j]+" ";
		reducedTagsStr+=entry.reducedTags[j]+" ";
		//		if (bothTags)
		//		    fullTagsStr+=entry.fullTags[j]+" ";
	    }
	    if (wordsStr.length()>maxWordsLen) 
		maxWordsLen=wordsStr.length();
	    if (reducedTagsStr.length()>maxReducedTagsLen)
		maxReducedTagsLen=reducedTagsStr.length();
	    if (fullTagsStr.length()>maxFullTagsLen)
		maxFullTagsLen=fullTagsStr.length();
	}
	maxWordsLen=(maxWordsLen>20 ? 20 : maxWordsLen);
	maxReducedTagsLen=(maxReducedTagsLen>20 ? 20 : maxReducedTagsLen);
	maxFullTagsLen=(maxFullTagsLen>60 ? 60 : maxFullTagsLen);

	System.out.println(name);
	for (int i=0; i<entries.size(); i++) {
	    ContextInfo entry=(ContextInfo)entries.get(i);
	    String wordsStr="";
	    String reducedTagsStr="";
	    String fullTagsStr="";
	    for (int j=0; j<entry.words.length; j++) {
		wordsStr+=entry.words[j]+" ";
		reducedTagsStr+=entry.reducedTags[j]+" ";
		//		if (bothTags)
		//		    fullTagsStr+=entry.fullTags[j]+" ";
	    }
	    System.out.println(danbikel.parser.util.SKUtil.leftJustify(4,i+") ")+ 
			       danbikel.parser.util.SKUtil.leftJustify(maxWordsLen,wordsStr)+
			       danbikel.parser.util.SKUtil.leftJustify(maxReducedTagsLen,reducedTagsStr)+
			       danbikel.parser.util.SKUtil.leftJustify(20,entry.filename+"/"+entry.sentNum));
	}
    }

}



