package danbikel.parser.examine2;

import danbikel.parser.Constants;
import danbikel.parser.HeadFinder;
import danbikel.parser.Language;
import danbikel.parser.Treebank;
import danbikel.parser.Settings;
import danbikel.parser.Nonterminal;
import danbikel.parser.Word;
import danbikel.parser.Words;
import danbikel.util.*;
import danbikel.lisp.*;
import java.util.*;
import java.io.*;


public abstract class ExamineCore {

    int count=0;
    String currentFilename="";
    int currentSentNum=0;

    boolean bothTags=false;
    static String defaultExtension=".tree";
    
    public ExamineCore() {
	
    }	
    
    
    
    abstract protected void process(Sexp tree);

    public void process(String filename)
	throws FileNotFoundException,IOException {
	//	System.err.println("reading file"+filename);
	int index=filename.lastIndexOf("/");
	currentFilename=filename.substring(index+1);
	currentSentNum=0;
	
	try {
	    //	    Training3 training = (Training3)Language.training();
	    SexpTokenizer tok = new SexpTokenizer(filename, Language.encoding(),
						  Constants.defaultFileBufsize);
	    Sexp curr = null;
	    while ((curr = Sexp.read(tok)) != null) {
		//		System.out.println("curr="+curr);
		process(curr);
		currentSentNum++;
	    
	    }
	}
	catch (UnsupportedEncodingException uee) {
	    System.err.println(uee);
	}
    }
    
    protected void showResults() 
	throws FileNotFoundException,IOException {
    }
	
    public void process(List files) 
	throws FileNotFoundException,IOException {
	
	int i=0;
	for (Iterator fileIter = files.iterator(); fileIter.hasNext(); ) {
	    String baseFileName=(String)fileIter.next();
	    //	    String inFileName=baseFileName+defaultExtension;
	    if (i++ % 50 ==0) 
		System.err.println(i);

	    process(baseFileName);
	}
	showResults();

    }

}
