/* *           Copyright (c) 2004, Daniel M. Bikel.
 *                         All rights reserved.
 * 
 *                Developed at the University of Pennsylvania
 *                Institute for Research in Cognitive Science
 *                    3401 Walnut Street
 *                    Philadelphia, Pennsylvania 19104
 * 			
 * 
 * For research or educational purposes only.  Do not redistribute.  For
 * complete license details, please read the file LICENSE that accompanied
 * this software.
 * 
 * DISCLAIMER
 * 
 * Daniel M. Bikel makes no representations or warranties about the suitability of
 * the Software, either express or implied, including but not limited to the
 * implied warranties of merchantability, fitness for a particular purpose, or
 * non-infringement. Daniel M. Bikel shall not be liable for any damages suffered
 * by Licensee as a result of using, modifying or distributing the Software or its
 * derivatives.
 * 
 */
package danbikel.parser.ppceme;

import java.util.*;
import java.io.*;
import danbikel.lisp.*;
import danbikel.parser.*;


public class Training7 extends Training {

    public Training7() throws FileNotFoundException, IOException {
	super();
	System.err.println("ppceme Training7 constructor");
    }
    public Sexp preProcess(Sexp tree) {
	stripDollarSigns(tree);
	prune(tree);
	//addBaseNPs(tree);
	//repairBaseNPs(tree);
	//    addGapInformation(tree);
	//    relabelSubjectlessSentences(tree);
	removeNullElements(tree);
	raisePunctuation(tree);
	identifyArguments(tree);
	stripAugmentations(tree);
	//fixSubjectlessSentences(tree);  this method now in English lang. package
	return tree;
    }

    public void postProcess(Sexp tree) {
	//unrepairBaseNPs(tree);
	//    super.postProcess(tree);
	//removeOnlyChildBaseNPs(tree);
	//System.out.println("after remove basenps = " + tree);
	//    canonicalizeNonterminals(tree);

	//raiseCodeNodes(tree);
	//System.out.println("after raiseCodeNodes " + tree);
	System.out.println("before stripArgAugAndCanonicalizeBases" + tree);	
	stripArgAugAndCanonicalizeBases(tree);
	System.out.println("after stripArgAugAndCanonicalizeBases" + tree);
    }


}
