package danbikel.parser.util;

import java.io.*;
import java.util.*;
import danbikel.util.*;
import danbikel.lisp.*;
import danbikel.parser.*;
import danbikel.parser.util.*;

public class CompareTwoSexp { 

    String ext1=null;
    String ext2=null;
    private static final int bufSize = 81920;

    public CompareTwoSexp(String ext1,String ext2) {
	this.ext1=ext1;
	this.ext2=ext2;
    }

    public void process(String file1Name, String file2Name,
			InputStream inStream1,InputStream inStream2) 
	throws IOException {
	String enc = System.getProperty("file.encoding");
	SexpTokenizer tok1 = new 
	    SexpTokenizer(inStream1, enc, bufSize);	
	SexpTokenizer tok2 = new 
	    SexpTokenizer(inStream2, enc, bufSize);	
	Sexp tree1,tree2;
	for (int i = 1; ((tree1 = Sexp.read(tok1)) != null); i++) {
	    tree2=Sexp.read(tok2);
	    SexpList words1=(SexpList)Util.collectTaggedWords(tree1);
	    SexpList words2=(SexpList)Util.collectTaggedWords(tree2);
	    if (words1.size()!=words2.size()) {
		System.out.println("-------------------------------------\n");
		System.out.println("file1Name="+file1Name);
		System.out.println("file2Name="+file2Name);		
		System.out.println("sentNum"+i+ 
				   " words1="+words1.size()+
				   " words2="+words2.size());
		System.out.println("tree1="+tree1);
		System.out.println("tree2="+tree2);
	    } else if (!(tree1.equals(tree2))) {
		System.out.println("-------------------------------------\n");
		System.out.println("file1Name="+file1Name);
		System.out.println("file2Name="+file2Name);		
		System.out.println("not equal!!");
		System.out.println("tree1="+tree1);
		System.out.println("tree2="+tree2);

	    }
	}
    }

	    
	

    public void process(List files) 
	throws IOException {
	for (Iterator fileIter = files.iterator(); fileIter.hasNext(); ) {
	    String baseFileName=(String)fileIter.next();
	    String file1Name=baseFileName+ext1;
	    String file2Name=baseFileName+ext2;
	    InputStream inStream1,inStream2=null;
	    //    System.out.println("file1Name="+file1Name);
	    // System.out.println("file2Name="+file2Name);
	    inStream1 = new FileInputStream(file1Name);
	    inStream2 = new FileInputStream(file2Name);
	    process(file1Name,file2Name,
		    inStream1,
		    inStream2);
	}
    }

    
    public static void main(String[] args) {
	String dir1=args[0];
	String dir2=args[1];
	String ext1=args[2];
	String ext2=args[3];

	ArrayList dirs=new ArrayList();
	dirs.add(new File(dir1));
	List files=SKUtil.expandDirectories(dirs,ext1,true,false);
	System.out.println("# files="+files.size());
	CompareTwoSexp compareThem=new CompareTwoSexp(ext1,ext2);
	try {
	    compareThem.process(files);
	}
	catch (Exception e) {
	    System.err.println(e);
	    e.printStackTrace();
	    System.exit(-1);
	}
    }
}
	
